//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "NIST_Type_8_data_converter_main_form.h"



//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{



   // returns a handle to the DLL, otherwise NULL
   hWSQ_library = LoadLibrary(L"WSQ_library.dll");

   if (hWSQ_library == NULL)
   {Application->MessageBox( L"Error: WSQ_library.dll not found", L"Error", MB_OK);}


   pRegisterWSQ = (RegisterWSQ) GetProcAddress(hWSQ_library, "_RegisterWSQ");
   pCreateBMPFromFile = (CreateBMPFromFile) GetProcAddress(hWSQ_library, "_CreateBMPFromFile");
   pSaveBMPToFile = (SaveBMPToFile) GetProcAddress(hWSQ_library, "_SaveBMPToFile");
   pCreateBMPFromWSQByteArray = (CreateBMPFromWSQByteArray) GetProcAddress(hWSQ_library, "_CreateBMPFromWSQByteArray");
   pSaveWSQByteArrayToImageFile = (SaveWSQByteArrayToImageFile) GetProcAddress(hWSQ_library, "_SaveWSQByteArrayToImageFile");
   pSetShowFilePropertiesDialog = (SetShowFilePropertiesDialog) GetProcAddress(hWSQ_library, "_SetShowFilePropertiesDialog");
   pShowFileConverter = (ShowFileConverter) GetProcAddress(hWSQ_library, "_ShowFileConverter");
   pWSQ_decode_stream = (WSQ_decode_stream) GetProcAddress(hWSQ_library, "_WSQ_decode_stream");
   pWSQ_encode_stream = (WSQ_encode_stream) GetProcAddress(hWSQ_library, "_WSQ_encode_stream");
   pConvertHBITMAPtoGrayScale256 = (ConvertHBITMAPtoGrayScale256) GetProcAddress(hWSQ_library, "_ConvertHBITMAPtoGrayScale256");
   pSaveHBITMAPtoFileAsGrayScale256BMP = (SaveHBITMAPtoFileAsGrayScale256BMP) GetProcAddress(hWSQ_library, "_SaveHBITMAPtoFileAsGrayScale256BMP");

   pCreateHBITMAPfromNISTType8BinaryField = (CreateHBITMAPfromNISTType8BinaryField)GetProcAddress(hWSQ_library, "_CreateHBITMAPfromNISTType8BinaryField");
//   pCreateHBITMAPfromNISTType8UncompressedBinaryField = (CreateHBITMAPfromNISTType8UncompressedBinaryField)GetProcAddress(hWSQ_library, "_CreateHBITMAPfromNISTType8UncompressedBinaryField");
//   pCreateHBITMAPfromNISTType8CompressedBinaryField = (CreateHBITMAPfromNISTType8CompressedBinaryField)GetProcAddress(hWSQ_library, "_CreateHBITMAPfromNISTType8CompressedBinaryField");
  pCreateNISTType8BinaryFieldfromHBITMAP = (CreateNISTType8BinaryFieldfromHBITMAP)GetProcAddress(hWSQ_library, "_CreateNISTType8BinaryFieldfromHBITMAP");
//   pCreateNISTType8UncompressedBinaryFieldfromHBITMAP = (CreateNISTType8UncompressedBinaryFieldfromHBITMAP)GetProcAddress(hWSQ_library, "_CreateNISTType8UncompressedBinaryFieldfromHBITMAP");
//   pCreateNISTType8CompressedBinaryFieldfromHBITMAP = (CreateNISTType8CompressedBinaryFieldfromHBITMAP)GetProcAddress(hWSQ_library, "_CreateNISTType8CompressedBinaryFieldfromHBITMAP");
   pReadType8DataCompressionType = (ReadType8DataCompressionType)GetProcAddress(hWSQ_library, "_ReadType8DataCompressionType");
   pReadType8DataWidth = (ReadType8DataWidth)GetProcAddress(hWSQ_library, "_ReadType8DataWidth");
   pReadType8DataHeight = (ReadType8DataHeight)GetProcAddress(hWSQ_library, "_ReadType8DataHeight");
   pReadSizeOfNISTType8BinaryField = (ReadSizeOfNISTType8BinaryField)GetProcAddress(hWSQ_library, "_ReadSizeOfNISTType8BinaryField");
   pSetNISTType8ImageColorInversion = (SetNISTType8ImageColorInversion)GetProcAddress(hWSQ_library, "_SetNISTType8ImageColorInversion");


   pGenerateSerialNumber = (GenerateSerialNumber) GetProcAddress(hWSQ_library, "_GenerateSerialNumber");
   pUnlockWSQLibrary = (UnlockWSQLibrary) GetProcAddress(hWSQ_library, "_UnlockWSQLibrary");


   if (pRegisterWSQ == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of RegisterWSQ failed", L"Error", MB_OK );}
   if (pCreateBMPFromFile == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of SaveBMPToFile failed", L"Error", MB_OK );}
   if (pSaveBMPToFile == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of CreateBMPFromFile failed", L"Error", MB_OK );}
   if (pCreateBMPFromWSQByteArray == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of CreateBMPFromWSQByteArray failed", L"Error", MB_OK );}
   if (pSaveWSQByteArrayToImageFile == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of SaveWSQByteArrayToImageFile failed", L"Error", MB_OK );}
   if (pSetShowFilePropertiesDialog == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of SetShowFilePropertiesDialog failed", L"Error", MB_OK );}
   if (pShowFileConverter == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of ShowFileConverter failed", L"Error", MB_OK );}
   if (pWSQ_decode_stream == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of WSQ_decode_stream failed", L"Error", MB_OK );}
   if (pWSQ_encode_stream == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of WSQ_encode_stream failed", L"Error", MB_OK );}
   if (pConvertHBITMAPtoGrayScale256 == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of ConvertHBITMAPtoGrayScale256 failed", L"Error", MB_OK );}
   if (pSaveHBITMAPtoFileAsGrayScale256BMP == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of SaveHBITMAPtoFileAsGrayScale256BMP failed", L"Error", MB_OK );}

   if (pCreateHBITMAPfromNISTType8BinaryField == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of CreateHBITMAPfromNISTType8BinaryField failed", L"Error", MB_OK );}
//   if (pCreateHBITMAPfromNISTType8UncompressedBinaryField == NULL)
//   {Application->MessageBox( L"Error: GetProcAddress of CreateHBITMAPfromNISTType8UncompressedBinaryField failed", L"Error", MB_OK );}
//   if (pCreateHBITMAPfromNISTType8CompressedBinaryField == NULL)
//   {Application->MessageBox( L"Error: GetProcAddress of CreateHBITMAPfromNISTType8CompressedBinaryField failed", L"Error", MB_OK );}
   if (pCreateNISTType8BinaryFieldfromHBITMAP == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of CreateNISTType8BinaryFieldfromHBITMAP failed", L"Error", MB_OK );}
//   if (pCreateNISTType8UncompressedBinaryFieldfromHBITMAP == NULL)
//   {Application->MessageBox( L"Error: GetProcAddress of CreateNISTType8UncompressedBinaryFieldfromHBITMAP failed", L"Error", MB_OK );}
//   if (pCreateNISTType8CompressedBinaryFieldfromHBITMAP == NULL)
//   {Application->MessageBox( L"Error: GetProcAddress of CreateNISTType8CompressedBinaryFieldfromHBITMAP failed", L"Error", MB_OK );}
   if (pReadType8DataCompressionType == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of ReadType8DataCompressionType failed", L"Error", MB_OK );}
   if (pReadType8DataWidth == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of ReadType8DataWidth failed", L"Error", MB_OK );}
   if (pReadType8DataHeight == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of ReadType8DataHeight failed", L"Error", MB_OK );}
   if (pReadSizeOfNISTType8BinaryField == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of ReadSizeOfNISTType8BinaryField failed", L"Error", MB_OK );}
   if (pSetNISTType8ImageColorInversion == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of SetNISTType8ImageColorInversion failed", L"Error", MB_OK );}


   if (pGenerateSerialNumber == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of GenerateSerialNumber failed", L"Error", MB_OK );}
   if (pUnlockWSQLibrary == NULL)
   {Application->MessageBox( L"Error: GetProcAddress of UnlockWSQLibrary failed", L"Error", MB_OK );}


ComboBoxCompression->Items->Add("Uncompressed");
ComboBoxCompression->Items->Add("ANSI/EIA-538-1988 facsimile compression");
ComboBoxCompression->ItemIndex = 0;

EditWidth->Text = "0";
EditHeight->Text = "0";





  SaveButton->Enabled = false;
  ConvertToType8Button->Enabled = false;

// SetNISTType8ImageColorInversion(int in_uncompressed_type8_image_inverted, int out_uncompressed_type8_image_inverted, int in_compressed_type8_image_inverted, int out_compressed_type8_image_inverted);
//(pSetNISTType8ImageColorInversion)(0,1,0,0); // inverted color HBITMAP
//(pSetNISTType8ImageColorInversion)(1,0,1,1); // inverted color Type-8 image




}
//---------------------------------------------------------------------------

void __fastcall TForm1::ConvertFromType8ButtonClick(TObject *Sender)
{



  OpenButton->Enabled = false;
  SaveButton->Enabled = false;
  ConvertFromType8Button->Enabled = false;
  ConvertToType8Button->Enabled = false;


	TOpenDialog *open_dialog = new TOpenDialog(NULL);

	type8_image_width = 0;
	type8_image_height = 0;
	type8_image_compression_type = 0;

    open_dialog->Filter = "Binary files|*.bin";
//    open_dialog->Filter = "All files|*.*";
	if ( open_dialog->Execute() ) {


   handle = _wopen(open_dialog->FileName.c_str(), O_RDONLY);

   if((ret = filelength(handle)) < 0)
   {Application->MessageBox( L"Error: filelength < 0", L"Error", MB_OK );}
   type8_input_stream_length = ret;


   if((infp = _wfopen(open_dialog->FileName.c_str(), L"rb")) == (FILE *)NULL)
   {Application->MessageBox( L"Error: open file failed", L"Error", MB_OK );}


   if(type8_input_data_stream != (unsigned char*)NULL)
   {free(type8_input_data_stream); type8_input_data_stream = (unsigned char*)NULL;}

   type8_input_data_stream = (unsigned char *)malloc(type8_input_stream_length * sizeof(unsigned char));
   if(type8_input_data_stream == (unsigned char *)NULL)
   {Application->MessageBox( L"Error: malloc for type8_input_data_stream failed", L"Error", MB_OK );}

   n = fread(type8_input_data_stream, sizeof(unsigned char), type8_input_stream_length, infp);
   if(n != type8_input_stream_length)
   {Application->MessageBox( L"Error: reading file failed", L"Error", MB_OK );}

   fclose(infp);

   close(handle);


//-------------

   type8_image_size_txt_file = ChangeFileExt(open_dialog->FileName, ".txt");

   char line[512];

   // open the file for reading -- "rt" means open the file for reading text
   //image_size_txt_filefp = _wfopen (type8_image_size_txt_file.c_str(), L"rt");

   if((image_size_txt_filefp = _wfopen (type8_image_size_txt_file.c_str(), L"rt")) != (FILE *)NULL)
   {

	type8_image_width = 0;
	type8_image_height = 0;
	type8_image_compression_type = 0;


 // get a line, up to 80 chars from image_size_txt_filefp done if NULL
   if(fgets(line, 80, image_size_txt_filefp) != NULL)
   {
	 sscanf (line, "%d", &type8_image_compression_type);// convert the string to int
   }
   if(fgets(line, 80, image_size_txt_filefp) != NULL)
   {
	 sscanf (line, "%d", &type8_image_width);// convert the string to int
   }
   if(fgets(line, 80, image_size_txt_filefp) != NULL)
   {
	 sscanf (line, "%d", &type8_image_height);// convert the string to int
   }

   fclose(image_size_txt_filefp);

   EditWidth->Text = IntToStr(type8_image_width);
   EditHeight->Text = IntToStr(type8_image_height);
   ComboBoxCompression->ItemIndex = type8_image_compression_type;

   }//   if(image_size_txt_filefp = _wfopen (type8_image_size_txt_file.c_str(), L"rt")) != (FILE *)NULL)
   else
   {
   type8_image_width = StrToIntDef(EditWidth->Text, 0);
   type8_image_height = StrToIntDef(EditHeight->Text, 0);
   type8_image_compression_type = ComboBoxCompression->ItemIndex;
   }//else --> if(fgets(line, 80, image_size_txt_filefp) != NULL)


   if((type8_image_width == 0)|(type8_image_height == 0))
   {
   Application->MessageBox( L"You must manually set the type8_width and type8_height and compression type of the image.", L"Warning", MB_OK );
   ConvertFromType8Button->Enabled = true;
   OpenButton->Enabled = true;
   return;
   }


//	OutputImage->Picture->Bitmap->Handle = CreateHBITMAPfromNISTType8UncompressedBinaryField(type8_image_width, type8_image_height, type8_image_compression_type, type8_input_data_stream, type8_input_stream_length);

	delete OutputImage->Picture->Bitmap;
	OutputImage->Picture->Bitmap = new Graphics::TBitmap();

	OutputImage->Picture->Bitmap->Handle = (HBITMAP)CopyImage((HANDLE)(pCreateHBITMAPfromNISTType8BinaryField)(type8_image_width, type8_image_height, type8_image_compression_type, type8_input_data_stream, type8_input_stream_length), IMAGE_BITMAP, 0, 0,LR_COPYRETURNORG);

//	if(type8_image_compression_type == 0)
//	{OutputImage->Picture->Bitmap->Handle = (HBITMAP)CopyImage((HANDLE)(pCreateHBITMAPfromNISTType8UncompressedBinaryField)(type8_image_width, type8_image_height, type8_input_data_stream, type8_input_stream_length), IMAGE_BITMAP, 0, 0,LR_COPYRETURNORG);}
//	else
//	{OutputImage->Picture->Bitmap->Handle = (HBITMAP)CopyImage((HANDLE)(pCreateHBITMAPfromNISTType8CompressedBinaryField)(type8_image_width, type8_image_height, type8_input_data_stream, type8_input_stream_length), IMAGE_BITMAP, 0, 0,LR_COPYRETURNORG);}

//	OutputImage->Picture->Bitmap->PixelFormat = pf24bit;


	OutputImage->Width = OutputImage->Picture->Bitmap->Width;
	OutputImage->Height = OutputImage->Picture->Bitmap->Height;

	}//if ( open_dialog->Execute() )


	delete open_dialog;


	OpenButton->Enabled = true;
	SaveButton->Enabled = true;
	ConvertFromType8Button->Enabled = true;
	ConvertToType8Button->Enabled = true;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::ConvertToType8ButtonClick(TObject *Sender)
{


  OpenButton->Enabled = false;
  SaveButton->Enabled = false;
  ConvertFromType8Button->Enabled = false;
  ConvertToType8Button->Enabled = false;


    TSaveDialog *save_dialog = new TSaveDialog( this );
	save_dialog->Filter = "BIN Files (*.bin)|*.bin";
    save_dialog->DefaultExt = "bin";


    if ( save_dialog->Execute() )
    {

	type8_image_width = OutputImage->Picture->Bitmap->Width;
	type8_image_height = OutputImage->Picture->Bitmap->Height;

	EditWidth->Text = IntToStr(type8_image_width);
	EditHeight->Text = IntToStr(type8_image_height);


	type8_image_compression_type = ComboBoxCompression->ItemIndex;

	type8_image_size_txt_file = ChangeFileExt(save_dialog->FileName, ".txt");

   char line[512];


   // open the file for reading -- "wt" means open the file for writing text
   //image_size_txt_filefp = _wfopen (type8_image_size_txt_file.c_str(), L"wt");

   if((image_size_txt_filefp = _wfopen (type8_image_size_txt_file.c_str(), L"wt")) != (FILE *)NULL)
   {
   fprintf(image_size_txt_filefp, "%d\n", type8_image_compression_type);
   fprintf(image_size_txt_filefp, "%d\n", type8_image_width);
   fprintf(image_size_txt_filefp, "%d", type8_image_height);

   fclose(image_size_txt_filefp);
   }//   if(image_size_txt_filefp = _wfopen (type8_image_size_txt_file.c_str(), L"rt")) != (FILE *)NULL)

   type8_output_data_stream = (pCreateNISTType8BinaryFieldfromHBITMAP)(OutputImage->Picture->Bitmap->Handle, type8_image_compression_type);

//   if(type8_image_compression_type == 0)
//   {type8_output_data_stream = (pCreateNISTType8UncompressedBinaryFieldfromHBITMAP)(OutputImage->Picture->Bitmap->Handle);}
//   else
//   {type8_output_data_stream = (pCreateNISTType8CompressedBinaryFieldfromHBITMAP)(OutputImage->Picture->Bitmap->Handle);}

   type8_output_stream_length = (pReadSizeOfNISTType8BinaryField)();


	save_type8_binary_field_filename = ChangeFileExt(save_dialog->FileName, ".bin");

   //	ShowMessage(type8_binary_field_length);

//=================
   if((outfp = _wfopen(save_type8_binary_field_filename.c_str(), L"wb")) == NULL)
   {Application->MessageBox( L"Error: open file failed", L"Error", MB_OK );}

   if((n = fwrite(type8_output_data_stream, 1, type8_output_stream_length, outfp)) != type8_output_stream_length)
   {Application->MessageBox( L"Error: write to file failed", L"Error", MB_OK );}

   fclose(outfp);
//=================


	String result_string = "The converted file was saved as:\n" + save_type8_binary_field_filename;
	ShowMessage(result_string);

    }

	delete save_dialog;


  OpenButton->Enabled = true;
  SaveButton->Enabled = true;
  ConvertFromType8Button->Enabled = true;
  ConvertToType8Button->Enabled = true;


}
//---------------------------------------------------------------------------

void __fastcall TForm1::OpenButtonClick(TObject *Sender)
{


//    HBITMAP hBitmap = NULL;

//    TOpenDialog *open_dialog = new TOpenDialog(this);
    TOpenDialog *open_dialog = new TOpenDialog(NULL);

    open_dialog->Filter = "All images|*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jp2;*.jpc;*.jpe;*.jpeg;*.png;*.gif;*.iff;*.ico;*.wmf;\
*.emf;*.jfif;*.rle;*.dib;*.win;*.vst;*.vda;*.tga;*.icb;*.fax;*.pcx;*.pcc;*.scr; *.rpf;*.rla;*.sgi;\
*.rgba;*.rgb;*.bw;*.psd;*.pdd;*.ppm;*.pgm;*.pbm;*.cel;*.pic;*.pcd;*.cut;*.psp;|FBI Wavelet Scalar Quantization (*.wsq)|*.wsq|\
Windows bitmaps (*.bmp)|*.bmp|Macintosh TIFF images (*.tiff)|*.tiff|PC TIFF images (*.tif)|*.tif|\
JPG images (*.jpg)|*.jpg|JPEG-2000 Part-1 (*.jp2)|*.jp2|JPEG-2000 Code Stream (*.jpc)|*.jpc|JPE images (*.jpe)|*.jpe|\
JPEG images (*.jpeg)|*.jpeg|Portable network graphic images (*.png)|*.png|\
Compuserve Graphic Interchange Format(*.gif)|*gif|Paintshop Pro images (*.psp)|*.psp|JFIF images (*.jfif)|*.jfif|\
Run length encoded Windows bitmaps (*.rle)|*.rle|Device independant Windows bitmaps (*.dib)|*.dib|\
Truevision images (*.win)|*.win|Truevision images (*.vst)|*.vst|Truevision images (*.vda)|*.vda|\
Truevision images (*.tga)|*.tga|Truevision images (*.icb)|*.icb|GFI fax images (*.fax)|*.fax|\
ZSoft Paintbrush images (*.pcx)|*.pcx|ZSoft Paintbrush images (*.pcc)|*.pcc|\
Word 5.x screen capture images (*.scr)|*.scr|Alias/Wavefront images (*.rpf)|*.rpf|Alias/Wavefront images (*.rla)|*.rla|\
SGI true color images (*.sgi)|*.sgi|SGI true color images with alpha (*.rgba)|*.rgba|SGI true color images (*.rgb)|*.rgb|\
SGI black/white images (*.bw)|*.bw|Photoshop images (*.psd)|*.psd|Photoshop images (*.pdd)|*.pdd|\
Portable pixel map images (*.ppm)|*.ppm|Portable gray map images (*.pgm)|*.pgm|Portable bitmap images (*.pbm)|*.pbm|\
Autodesk images (*.cel)|*.cel|Autodesk images (*.pic)|*.pic|Kodak Photo-CD images (*.pcd)|*.pcd|\
Dr. Halo images (*.cut)|*.cut|Amiga Bitmap Graphic (8 bits)|*.iff|Windows icons (*.ico)|*.ico|\
Windows metafiles (*.wmf)|*.wmf|Windows enhanced meta files (*.emf)|*.emf";



    if ( open_dialog->Execute() )
    {

	   hBitmap = (pCreateBMPFromFile)(System::UTF8Encode(open_dialog->FileName).c_str());



        if ( hBitmap )
        {
            SaveButton->Enabled = true;
// Take and use Handle of HBitmap directly from WSQ image library DLL.
// If the WSQ image library is called to load or save another picture, you will lose the current image
          OutputImage->Picture->Bitmap->Handle = hBitmap;

//Make a copy of hBitmap into OutputImage->Picture
//            OutputImage->Picture->Bitmap->Handle  = (HBITMAP)CopyImage((HANDLE)hBitmap, IMAGE_BITMAP, 0, 0,LR_COPYRETURNORG);

            OutputImage->Width = OutputImage->Picture->Bitmap->Width;
            OutputImage->Height = OutputImage->Picture->Bitmap->Height;
            Invalidate();
        }
        else
        {
            Application->MessageBox(L"Unable to load file", L"WSQ library error", MB_OK | MB_ICONERROR );
        }
    }

    delete open_dialog;





}
//---------------------------------------------------------------------------

void __fastcall TForm1::SaveButtonClick(TObject *Sender)
{




	TSaveDialog *save_dialog = new TSaveDialog( this );
	save_dialog->Filter = "WSQ Files (*.wsq)|*.wsq|Windows BMP (*.bmp)|*.bmp|TIFF Files (*.tif)|*.tif|PNG Files (*.png)|*.png|JPEG Files (*.jpg)|*.jpg|Targa Files (*.tga)|*.tga|SGI Files (*.rgb)|*.rgb|JPEG-2000 Part-1 (*.jp2)|*.jp2|JPEG-2000 Code Stream (*.jpc)|*.jpc|PBM - Portable Bitmap Format (*.pbm)|*.pbm|PGM - Portable Graymap Format (*.pgm)|*.pgm|PPM - Portable Pixmap Format (*.ppm)|*.ppm";
	save_dialog->DefaultExt = "wsq";



	if ( save_dialog->Execute() )
	{
	  (pSetShowFilePropertiesDialog)(1);
	  (pSaveBMPToFile)(OutputImage->Picture->Bitmap->Handle, System::UTF8Encode(save_dialog->FileName).c_str(), save_dialog->FilterIndex);
	}

	delete save_dialog;


}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

